import sys, os, time, re, string, pwd
import gtk, gobject, gtk.glade
import shutil
#import ui
import urllib

def GetCDMountPoint():
    mtab = "/etc/mtab"
    
    getName = lambda x: x.split( "/" )[-1]
    if not os.path.exists( mtab ):
        log.Log( "Wasn't able to locate mtab" )
        cd = GetCD()
        return [( cd, getName( cd ) )]
    
    list = []
    for line in file( "/etc/mtab" ):
        mpoint, fsys = line.split()[1:3]
        if fsys == "iso9660" or fsys == "cd9960":
            log.Log( "Detected CD drive " + mpoint )
            list.append( ( mpoint, mpoint.split( "/" )[-1] ) )
    
    if not list:
        cd = GetCD()
        return [( cd, getName( cd ) )]
    
    return list

def GetCD():
    cdpath = False
    # Lifted almost completely out of freevo (thanks dischi ;)
    if not os.path.isfile( '/etc/fstab' ):
        return cdpath
    re_cd        = re.compile( '^(/dev/cdrom[0-9]*|/dev/[am]?cd[0-9]+[a-z]?)[ \t]+([^ \t]+)[ \t]+', re.I )
    re_cdrec     = re.compile( '^(/dev/cdrecorder[0-9]*)[ \t]+([^ \t]+)[ \t]+', re.I )
    re_dvd       = re.compile( '^(/dev/dvd[0-9]*)[ \t]+([^ \t]+)[ \t]+', re.I )
    re_iso       = re.compile( '^([^ \t]+)[ \t]+([^ \t]+)[ \t]+(iso|cd)9660', re.I )
    re_automount = re.compile( '^none[ \t]+([^ \t]+).*supermount.*dev=([^,]+).*', re.I )
    re_bymountcd = re.compile( '^(/dev/[^ \t]+)[ \t]+([^ ]*cdrom[0-9]*)[ \t]+', re.I )
    re_bymountdvd= re.compile( '^(/dev/[^ \t]+)[ \t]+([^ ]*dvd[0-9]*)[ \t]+', re.I )
    fd_fstab = open( '/etc/fstab' )
    for line in fd_fstab:
        # Match on the devices /dev/cdrom, /dev/dvd, and fstype iso9660
        match_cd        = re_cd.match( line )
        match_cdrec     = re_cdrec.match( line )
        match_dvd       = re_dvd.match( line )
        match_iso       = re_iso.match( line )
        match_automount = re_automount.match( line )
        match_bymountcd = re_bymountcd.match( line )
        match_bymountdvd= re_bymountdvd.match( line )
        mntdir = ''
        if match_cd or match_bymountcd:
            m = match_cd or match_bymountcd
            mntdir = m.group( 2 )
        elif match_cdrec:
            mntdir = match_cdrec.group( 2 )
        elif match_dvd or match_bymountdvd:
            m = match_dvd or match_bymountdvd
            mntdir = m.group( 2 )
        elif match_iso:
            mntdir = match_iso.group( 2 )
        elif match_automount:
            mntdir = match_automount.group( 1 )
        if mntdir:
            cdpath = mntdir
    fd_fstab.close()
    if cdpath:
        log.Log( "Detected CD drive " + cdpath )
    return cdpath

# FIXME: UI Code should be moved to ui.py #378 
class Download:
    widget = None
    uitype = None
    def __init__( self, remote_uri, local_uri, cache=False, uitype="popup", widget=None ):
        self.widget = widget
        self.cache = cache
        self.local_uri = urllib.unquote(local_uri)        
        
        if self.CheckCache() and self.cache:
            self.Complete()
            return
        
        if uitype == "popup":
            #self.wn_downloader = ui.Window( "wn_downloader" )
            #self.wn_downloader['lb_file'].set_text( remote_uri )
            pass
        else:
            # http://labix.org/snippets/progress-cell
            pass
        
        if os.path.isfile( remote_uri ):
            shutil.copy( remote_uri, self.local_uri )
        elif remote_uri.startswith ( "http://" ) or remote_uri.startswith ( "ftp://" ):
            urllib.urlretrieve( remote_uri, self.local_uri, self.UpdateProgress )
            #self.wn_downloader['wn_downloader'].hide()
        self.Complete()
          
    def UpdateProgress( self, blocks, block_size, total_size ):
            percentage = float ( blocks * block_size ) / total_size
            if percentage > 1:
                percentage = 1
                
            text_percent = "%s" % int ( percentage * 100 )
            if self.widget:
                #self.widget.set_text( text_percent + " %" )
                #self.widget.set_fraction( percentage )
                pass
            else:
                #self.wn_downloader['pb_downloader'].set_text( text_percent + " %" )
                #`self.wn_downloader['pb_downloader'].set_fraction( percentage )
                print "\rDownloading : %d" % (percentage * 100)
                sys.stdout.flush()
                pass
            while gtk.events_pending():
                gtk.main_iteration()
                
    def Complete ( self ):
        if self.local_uri.endswith( "gz" ):
            raw_file = self.local_uri.replace( ".gz", "" )
            if os.path.isfile( self.local_uri ):
                if os.path.isfile( raw_file ):
                    os.remove( raw_file )
                os.system( "gzip -d " + self.local_uri.replace( " ", "\\ " ) )
        if self.widget:
            pass
        
    def CheckCache ( self ):
        if self.local_uri.endswith( "gz" ): ## or wdi
            cache_file = self.local_uri.replace( ".gz", "" )
        else:
            cache_file = self.local_uri
            
        if self.cache > 1:
            cache_timeout = self.cache * 60 * 60 * 24
        else:
            cache_timeout = 86400
        
        if os.path.isfile( cache_file ):
            repo_cache = os.stat( cache_file )
            repo_mtime = repo_cache.st_mtime
            repo_mtime += cache_timeout
            if ( repo_mtime < time.time() ):
                os.remove( cache_file )
                return False
        else:
            return False
        return True
        
def printNestedStuff ( stuff, grow = 3, indent = 0, noFirstLine = False ):
    """ Prints a lot of nested lists and dicts in a way that is readable """
    if type( stuff ) in ( list, tuple ):
        char = type( stuff ) == list and "[]" or "()"
        if not noFirstLine:
            print " "*indent + char[0]
        else: print char[0]
        for i in range( len( stuff ) ):
            item = stuff[i]
            printNestedStuff( item, grow, indent+grow )
            if not i +1 >= len( stuff ):
                print ","
            else: print
        sys.stdout.write( " "*indent + char[1] )
        
    elif type( stuff ) == dict:
        if not noFirstLine:
            print " "*indent + "{"
        else: print "{"
        pairs = [( k, v ) for k, v in stuff.iteritems()]
        for i in range( len( pairs ) ):
            k, v = pairs[i]
            printNestedStuff( k, grow, indent+grow )
            sys.stdout.write( " : " )
            printNestedStuff( v, grow, indent+grow, True )
            if not i+1 >= len( pairs ):
                print ","
            else: print
        sys.stdout.write( " "*indent + "}" )
    
    else:
        if not noFirstLine:
            sys.stdout.write( " "*indent + str( stuff ) )
        else: sys.stdout.write( str( stuff ) )

